#!/usr/bin/perl
use strict;
use warnings;
use lib qw(./lib);
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use CGI::Session;
use Hatena::API::Auth;

# CGI Υ֥Ȥ롥 
my $q = CGI->new;

# ϤƤǧ API Υ֥Ⱥ 
#   api_key  secret ˤϡǧڥ (http://auth.hatena.ne.jp/) 
#   ȯԤƤäͤ򥻥åȤ롥 
my $api = Hatena::API::Auth->new({
    api_key => '..', secret => '..'
});
# Хå PATH_INFO
#   ˥ХåȾȲ򤪤ʤ 
my $VERIFY_PATH = '/verify.hatena';
# 󡦥󥯤 URI  
my $login_uri = $api->uri_to_login({foo => 'bar'}); 

my $action_uri = ''; # OpenID (ϤƤʤǤ̤) 
sub process_login { die "cannot /login" } # OpenID(ϤƤʤǤ̤) 

# Ȳ񥵥֥롼 
#  Хå URI Ϥ줿ǧھ(cert ѥ᡼)¤줿 
#  Τɤ API ȤäǧڥФ˾Ȳ񤹤롥
#  Ȳ顤Ⱦ֤ΤǡФƤ 
#
#  Ȥ: my $user_info = process_verify($api, $q);
#  : ȾǼ᤿ϥå塦ե 
#     -field ˥ȾΥڡڤ 
#  :
#    $api -- ǧ API ֥
#    $q   -- CGI ֥
sub process_verify {
    my($api, $q) = @_;
    # Хå URI  cert ѥ᡼Ф 
    my $cert = $q->param('cert');
    # cert ѥ᡼ǧڥФ˾Ȳ񤷤Ƥ餦 
    my $user = $api->login($cert) or die $api->errstr;
    # ȲޤäȾФ 
    return +{
        # -fields Ϥɤ̾Υեɤ뤫򼨤 
        -fields => 'name image_url thumbnail_url',
        # Ⱦե 
        name => $user->name,
        image_url => $user->image_url,
        thumbnail_url => $user->thumbnail_url
    };
}

# ʲ API ʬ 

# CGI-Session Τ 
my $session; # å󡦥֥ȤǼѿ 
my $DNS = "driver:file"; # åǼˤϥեѤ 
my $OPT = {Directory=>'./session'}; # åǼǥ쥯ȥ 
my $SID = 'ss'; # åIDϿ륯å̾ 
# ֥饦åssϤ顤åƤե뤫ɤ߼ 
if (my $sid = $q->cookie($SID)) {
    $session = CGI::Session->new($DNS, $sid, $OPT) or die CGI::Session->errstr;
    if ($sid ne $session->id) {
        # ͭ¤᤮ȯԤƤʤåξϺ 
        $session->delete;
        $session = undef;
    }
}
if ($q->path_info eq '/login') {
    process_login($api, $q); # OpenIDΥ򤪤ʤ 
} elsif ($q->path_info eq $VERIFY_PATH) {
    # Ȳ򤪤ʤ 
    my $user_info = process_verify($api, $q);
    # ǧξϥå򿷤ꥢȾϿ 
    $session->delete if $session;
    $session = CGI::Session->new($DNS, undef, $OPT) or die CGI::Session->errstr;
    $session->expire('+1h');
    $session->param(%$user_info);
    # åID򥯥å˥åȤ 
    print $q->redirect(
        -uri => $q->url,
        -cookie => $q->cookie($SID, $session->id)
    );
    exit;
} elsif ($q->path_info eq '/logout') {
    # åȥå뤳ȤǥȤ 
    $session->delete if $session;
    print $q->redirect(
        -uri => $q->url,
        -cookie => $q->cookie(
            -name => $SID, -value => '', -expires => '-1d'
        )
    );
    exit;
}
# ڡɽ 
print $q->header(-charset => 'UTF-8');
print $q->start_html('Web Auth'), $q->h1('Web Auth');
if (! $session && $login_uri) {
    # OpenID ʳΥ󡦥󥯤ɽ롥 
    print $q->p($q->a({-href=>$login_uri}, 'LOGIN'));
} elsif (! $session && $action_uri) {
    # OpenID Υ󡦥եɽ롥 
    print
       $q->start_form(-action => $action_uri),
       'OpenID: ',
       $q->textfield(-name => 'openid_url'),
       $q->submit(-value => ' LOGIN '),
       $q->end_form;
} else {
    # å˵ϿƤ륢Ⱦȥȥ󥯤ɽ롥 
    print
        $q->p($q->a({-href=>$q->url.'/logout'}, 'LOGOUT')),
        $q->ul(
            $q->li([map {
                $q->escapeHTML("$_ = " . $session->param($_))
            } split / /, $session->param('-fields')])
        );
}
print $q->end_html, "\n";
